<?php

namespace Testpackageprovider\Test\Http\Controllers;

use App\Http\Controllers\PublicController as CMSPublicController;
use Testpackageprovider\Test\Interfaces\TestarticlesRepositoryInterface;

class TestarticlesPublicController extends CMSPublicController
{
    /**
     * Constructor.
     *
     * @param type \Testpackageprovider\Testarticles\Interfaces\TestarticlesRepositoryInterface $testarticles
     *
     * @return type
     */
    public function __construct(TestarticlesRepositoryInterface $testarticles)
    {
        $this->repository = $testarticles;
        parent::__construct();
    }

    /**
     * Show testarticles's list.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function index()
    {
        $testarticles = $this->repository->scopeQuery(function($query){
            return $query->orderBy('id','DESC');
        })->paginate();

        return $this->theme->of('test::public.testarticles.index', compact('testarticles'))->render();
    }

    /**
     * Show testarticles.
     *
     * @param string $slug
     *
     * @return response
     */
    protected function show($slug)
    {
        $testarticles = $this->repository->scopeQuery(function($query) use ($slug) {
            return $query->orderBy('id','DESC')
                         ->where('slug', $slug);
        })->first(['*']);

        return $this->theme->of('test::public.testarticles.show', compact('testarticles'))->render();
    }
}
